window.onload = function() {
  const savedText = window.saved_text;

  if (savedText !== '') {
    // Find all text nodes within the body and wrap instances of the saved text with <b> tags
    const body = document.querySelector('body');
    highlightTextNodes(body, savedText);
  }
};
  
function highlightTextNodes(node, savedText) {
  if (node.nodeType === Node.TEXT_NODE) {
    const content = node.textContent;
    const highlightedContent = content.replace(new RegExp(savedText, 'gi'), '<b>$&</b>');
    if (content !== highlightedContent) {
      const wrapper = document.createElement('span');
      wrapper.innerHTML = highlightedContent;
      node.parentNode.replaceChild(wrapper, node);
    }
  } else {
    const children = node.childNodes;
    for (let i = 0; i < children.length; i++) {
      highlightTextNodes(children[i], savedText);
    }
  }
}